

//enumerated type definition file...


//#####################################################################################################################################################################
// POLYGON-ANIMATION enumerations...

enum MESH_OBJECT_TYPE	{ OBJECT_ROBOTPART = 0, OBJECT_GUNBARREL = 1 };



//ROBOT PART TYPE - types...

#define ROBOPARTTYPE_LOCOMOTION			0
#define ROBOPARTTYPE_TURRETWEAPON		1
#define ROBOPARTTYPE_STATIONARYWEAPON	2
#define ROBOPARTTYPE_SENSOR				3
#define ROBOPARTTYPE_MANIPULATOR		4
#define ROBOPARTTYPE_SPACER				5



//DRAWING TYPES

#define DRAW_POLYS						0
#define DRAW_OUTLINES					1
#define DRAW_POLYS_AND_OUTLINES			2




//ROBOT-STATE TYPES

#define ROBOTSTATE_IDLE					0
#define ROBOTSTATE_MOVING				1
#define ROBOTSTATE_ATTACKING			2
#define ROBOTSTATE_DEPLOYING			3
#define ROBOTSTATE_DEPLOYED				4
#define ROBOTSTATE_SCAVENGING			5
#define ROBOTSTATE_DEPOSITING			6


//BUILDING-STATE TYPES

#define BUILDINGSTATE_IDLE				0
#define BUILDINGSTATE_AOPENING			1
#define BUILDINGSTATE_AOPEN				2
#define BUILDINGSTATE_BOPENING			3
#define BUILDINGSTATE_BOPEN				4
#define BUILDINGSTATE_ACLOSING			5
#define BUILDINGSTATE_BCLOSING			6
#define BUILDINGSTATE_DEPLOYING			7
#define BUILDINGSTATE_DEPLOYED			8


//CURSOR TYPES

#define CURSOR_ARROW					0
#define CURSOR_SELECTION				1
#define CURSOR_MOVE						2
#define CURSOR_ATTACK					3
#define CURSOR_FORCEATTACK				4
#define CURSOR_LINKFENCE				5
#define CURSOR_UNLINKFENCE				6
#define CURSOR_SCAVENGE					7
#define CURSOR_DEPOSIT					8




//WEAPON TYPES

#define WEAPONTYPE_PROJECTILE			0
#define WEAPONTYPE_MISSILE				1
#define WEAPONTYPE_ROCKET				2



//EXPLOSION TYPES


#define EXPLOSIONTYPE_FIREBOMB			0
#define EXPLOSIONTYPE_SHOCKWAVE			1



//BUILDING TYPES


#define BUILDINGTYPE_FACTORY			0
#define BUILDINGTYPE_PROP				1
#define BUILDINGTYPE_FENCE				2



//HUD PART FILTER TYPES

#define HUDFILTER_LEGS					0
#define HUDFILTER_TURRETS				1
#define HUDFILTER_SENSORS				2
#define HUDFILTER_BUILDS				3

//PARTICLE TYPES

#define PARTICLETYPE_GLITTER			0
#define PARTICLETYPE_SMOKE				1



//OBJECT types

#define OBJECTTYPE_DEBRIS				0
#define OBJECTTYPE_TREE					1
#define OBJECTTYPE_METEOR				2




//ROBOT BEHAVIOUR STATES

#define ROBOTBEHAVIOUR_AUTOATTACK		0
#define ROBOTBEHAVIOUR_DEFEND			1
#define ROBOTBEHAVIOUR_ROAM				2
#define ROBOTBEHAVIOUR_SCAVENGE			3
