

#include "stdafx.h"
#include "metalwar.h"


void MOUSE::un_click(void){

	Lclicked = 0;
	Rclicked = 0;
	Mclicked = 0;

}

//#####################################################################################################################################################################
// handle() - handles the keyboard presses...

void KEYBOARD::handle(void){
int a;

	for (a=0;a<255;a++){
		
		keypressed[a] = 0;
		
		if (getkey(a)) keydown[a] = 1;
	
		if (keydown[a] == 1 && !getkey(a)) {
			keydown[a] = 0;
			keypressed[a] = 1;
		}
	}
}


//#####################################################################################################################################################################
// handle() - handles the mouse functionality...

void MOUSE::handle(void){
	POINT CurPoint;

	ox = x;
	oy = y;
	GetCursorPos(&CurPoint);
	x = CurPoint.x;
	y = CurPoint.y;

	WINDOWPLACEMENT twnd,tmwnd;
	game.mainDialog->m_MAINVIEW.GetWindowPlacement(&twnd);
	game.mainDialog->GetWindowPlacement(&tmwnd);


	game.display.camera.windowx = twnd.rcNormalPosition.left;
	game.display.camera.windowy = twnd.rcNormalPosition.top;
	game.display.camera.windowsx = twnd.rcNormalPosition.right - twnd.rcNormalPosition.left;
	game.display.camera.windowsy = twnd.rcNormalPosition.bottom - twnd.rcNormalPosition.top;



	if (!this->Rb){
		omx = mx;
		omy = my;

		mx = ((x - twnd.rcNormalPosition.left - tmwnd.rcNormalPosition.left - 3) / game.display.camera.windowsx * game.display.camera.resx);
		my = ((y - twnd.rcNormalPosition.top - tmwnd.rcNormalPosition.top - 22) / game.display.camera.windowsy * game.display.camera.resy);

		ocmx = cmx;
		ocmy = cmy;

		cmx = ((x - twnd.rcNormalPosition.left - tmwnd.rcNormalPosition.left - 3) / game.display.camera.windowsx * game.display.camera.resx) - game.display.camera.Lshift;
		cmy = ((y - twnd.rcNormalPosition.top - tmwnd.rcNormalPosition.top - 22) / game.display.camera.windowsy * game.display.camera.resy) - game.display.camera.Tshift;
	} 
	if (this->Rclicked) {
		omx = mx;
		omy = my;

		ocmx = cmx;
		ocmy = cmy;
	}



	if (Lb && (fabs(Ldmx-x) > 0 || fabs(Ldmy-y) > 0)){
		Ldrag = 1;
	}

	if (Ldragged) Ldragged = 0;
	if (Rdragged) Rdragged = 0;

	if (Ldrag && !Lb){
		Ldragged = 1;
		Ldrag = 0;
	}

	if (Rb && (fabs(Rdmx-x) > 0 || fabs(Rdmy-y) > 0)){
		Rdrag = 1;
	}

	if (Rdrag && !Rb){
		Rdragged = 1;
		Rdrag = 0;
	}

	extern S_MESH *mcube;

	if (game.control.keyboard.keydown[RK_D]){
		game.display.camera.cx += (30.0f*cos(DEG2RAD(-game.display.camera.az)))*(game.display.avtime/50.0f);
		game.display.camera.cy += (30.0f*sin(DEG2RAD(-game.display.camera.az)))*(game.display.avtime/50.0f);
		
		mcube->rotatez( 5.0 );
	}
	if (game.control.keyboard.keydown[RK_A]){
		game.display.camera.cx += (30.0f*cos(DEG2RAD(-game.display.camera.az+180)))*(game.display.avtime/50.0f);
		game.display.camera.cy += (30.0f*sin(DEG2RAD(-game.display.camera.az+180)))*(game.display.avtime/50.0f);
		
		mcube->rotatez( -5.0 );
	}
	if (game.control.keyboard.keydown[RK_S]){
		game.display.camera.cx += (30.0f*cos(DEG2RAD(-game.display.camera.az-90)))*(game.display.avtime/50.0f);
		game.display.camera.cy += (30.0f*sin(DEG2RAD(-game.display.camera.az-90)))*(game.display.avtime/50.0f);
		
		mcube->rotatex( 5.0 );
	}
	if (game.control.keyboard.keydown[RK_W]){
		game.display.camera.cx += (30.0f*cos(DEG2RAD(-game.display.camera.az+90)))*(game.display.avtime/50.0f);
		game.display.camera.cy += (30.0f*sin(DEG2RAD(-game.display.camera.az+90)))*(game.display.avtime/50.0f);
	
		mcube->rotatex( -5.0 );
	}


	find_3d_pos();

}

//#####################################################################################################################################################################
//returns a 3D position on the map from the 2D screen coordinates of the mouse...

void MOUSE::find_3d_pos(void){
/*	
	int a,collision=0;
	POLY		*poly;
	
	
	float xpos = ((game.display.camera.mx-(game.display.camera.Lshift))*((game.display.camera.zoom)))/600.0;
	float ypos = -((game.display.camera.my-(game.display.camera.Tshift))*((game.display.camera.zoom)))/600.0;
	
	float cam_planex1 = ( (0.0 ) * game.display.camera.COSaz) + ((0.0 ) * -game.display.camera.SINaz);
	float cam_planey1 = (( ((0.0 ) * game.display.camera.SINaz) + ((0.0 ) * game.display.camera.COSaz) ) * game.display.camera.COSax) + ((0.0f) * -game.display.camera.SINax);
	float cam_planez1 = (( ((0.0 ) * game.display.camera.SINaz) + ((0.0 ) * game.display.camera.COSaz) ) * game.display.camera.SINax) + ((0.0f) * game.display.camera.COSax);
	
	float cam_planex2 = ( (100.0 ) * game.display.camera.COSaz) + ((0.0 ) * -game.display.camera.SINaz);
	float cam_planey2 = (( ((100.0 ) * game.display.camera.SINaz) + ((0.0 ) * game.display.camera.COSaz) ) * game.display.camera.COSax) + ((0.0f) * -game.display.camera.SINax);
	float cam_planez2 = (( ((100.0 ) * game.display.camera.SINaz) + ((0.0 ) * game.display.camera.COSaz) ) * game.display.camera.SINax) + ((0.0f) * game.display.camera.COSax);
	
	float cam_planex3 = ( (100.0 ) * game.display.camera.COSaz) + ((100.0 ) * -game.display.camera.SINaz);
	float cam_planey3 = (( ((100.0 ) * game.display.camera.SINaz) + ((100.0 ) * game.display.camera.COSaz) ) * game.display.camera.COSax) + ((0.0f) * -game.display.camera.SINax);
	float cam_planez3 = (( ((100.0 ) * game.display.camera.SINaz) + ((100.0 ) * game.display.camera.COSaz) ) * game.display.camera.SINax) + ((0.0f) * game.display.camera.COSax);

	cam_planez1 += game.display.camera.zoom;
	cam_planez2 += game.display.camera.zoom;
	cam_planez3 += game.display.camera.zoom;

	
	VECTOR	Edge1, Edge2;
	VECTOR	t_Normal;
	VECTOR	t_Origin;
	
//	t_Origin.set(0.0,0.0, -1000000.0);// - game.display.camera.zoom);//game.display.camera.zoom - 100);
	
	t_Origin.set(xpos,ypos, 0.0f);// - game.display.camera.zoom);//game.display.camera.zoom - 100);
	
	VECTOR  t_PlaneDist1;
	t_PlaneDist1.set(cam_planex1, cam_planey1, cam_planez1);
				
	Edge1.set(cam_planex2-cam_planex1, cam_planey2-cam_planey1, cam_planez2-cam_planez1);
	Edge2.set(cam_planex3-cam_planex1, cam_planey3-cam_planey1, cam_planez3-cam_planez1);

				
	t_Normal = MWCrossProduct(&Edge1, &Edge2);
	t_Normal.MakeUnit();
				
	float t_PlaneDist2 = MWDotProduct( &t_PlaneDist1, &t_Normal);
				
	VECTOR    t_Vector;

	t_Vector.set( (-game.control.mouse.y)/10000.0, (game.control.mouse.x)/10000.0, 1.0);//game.display.camera.zoom);//0.0 + game.display.camera.zoom);
	float t = distRayPlane( t_Origin, t_Vector, t_Normal, t_PlaneDist2);
				
	if (t > 0){
	
		VECTOR IP;
		IP.set ( t_Origin.x + (t_Vector.x * t),t_Origin.y + (t_Vector.y * t),t_Origin.z + (t_Vector.z * t) );
						
		float nx = IP.x;
		float ny = IP.y;
		float nz = IP.z;
						
		float ttny = (( (ny) * game.display.camera.MINCOSax) + ((nz - game.display.camera.zoom) * -game.display.camera.MINSINax));
						
		gridx = (( (nx) * game.display.camera.MINCOSaz) + ((ttny) * -game.display.camera.MINSINaz));
		gridy = ((( ((nx) * game.display.camera.MINSINaz) + ((ttny) * game.display.camera.MINCOSaz) )));

		gridx += game.display.camera.cx;
		gridy += game.display.camera.cy;

	}

	this->mgridx = (int) (gridx / 20.0);
	this->mgridy = (int) (gridy / 20.0);

	if (game.control.mouse.snapToGrid && game.control.mouse.addingTile && game.mainDialog->m_LISTtileset.GetCurSel() > -1){
		
		if (TILE *curTile = game.resources.tileset.tile[game.mainDialog->m_LISTtileset.GetCurSel()]){
	
//x-snapping...			
			if (game.resources.mapGrid.grid[this->mgridx - (int)(curTile->gsx / 2.0)][this->mgridy].filled &&
				!game.resources.mapGrid.grid[this->mgridx + (int)(curTile->gsx / 2.0)][this->mgridy].filled){
			
				int timeout=0;
				do{
					if (game.resources.mapGrid.grid[this->mgridx - (int)(curTile->gsx / 2.0)][this->mgridy].filled){
						this->mgridx++;
					} else break;
					timeout++;
				}while(timeout<129);
		
			} else if (game.resources.mapGrid.grid[this->mgridx + (int)(curTile->gsx / 2.0)][this->mgridy].filled &&
				!game.resources.mapGrid.grid[this->mgridx - (int)(curTile->gsx / 2.0)][this->mgridy].filled){
			
				int timeout=0;
				do{
					if (game.resources.mapGrid.grid[this->mgridx + (int)(curTile->gsx / 2.0)-1][this->mgridy].filled){
						this->mgridx--;
					} else break;
					timeout++;
				}while(timeout<129);
			}

//y-snapping...		
			if (game.resources.mapGrid.grid[this->mgridx][this->mgridy - (int)(curTile->gsy / 2.0)].filled &&
				!game.resources.mapGrid.grid[this->mgridx][this->mgridy + (int)(curTile->gsy / 2.0)].filled){
			
				int timeout=0;
				do{
					if (game.resources.mapGrid.grid[this->mgridx][this->mgridy - (int)(curTile->gsy / 2.0)].filled){
						this->mgridy++;
					} else break;
					timeout++;
				}while(timeout<129);
		
			} else if (game.resources.mapGrid.grid[this->mgridx][this->mgridy + (int)(curTile->gsx / 2.0)].filled &&
				!game.resources.mapGrid.grid[this->mgridx][this->mgridy - (int)(curTile->gsx / 2.0)].filled){
			
				int timeout=0;
				do{
					if (game.resources.mapGrid.grid[this->mgridx][this->mgridy + (int)(curTile->gsx / 2.0)-1].filled){
						this->mgridy--;
					} else break;
					timeout++;
				}while(timeout<129);
			}

		}

	}*/
}




//#####################################################################################################################################################################
// MWCrossProduct() - works out the cross-product of the vector...
/*
VECTOR MWCrossProduct( VECTOR *v1, VECTOR *v2 )
{
	
	VECTOR t_v;
	
	float X = (v1->y * v2->z) -  (v1->z * v2->y);
	float Y = (v1->z * v2->x) -  (v1->x * v2->z);
	float Z = (v1->x * v2->y) -  (v1->y * v2->x);

	t_v.set(X,Y,Z);

	return t_v;
}
*/