// MapEditorDlg.h : header file
//

#if !defined(AFX_MAPEDITORDLG_H__90F747E2_D3A0_42AD_B82B_8B03DB89C6C2__INCLUDED_)
#define AFX_MAPEDITORDLG_H__90F747E2_D3A0_42AD_B82B_8B03DB89C6C2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMapEditorDlg dialog

class CMapEditorDlg : public CDialog
{
// Construction
public:
	CMapEditorDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMapEditorDlg)
	enum { IDD = IDD_MAPEDITOR_DIALOG };
	CButton	m_CHKsnapToGrid;
	CButton	m_CHKflipVert;
	CButton	m_CHKflipHoriz;
	CListBox	m_LISTfeatures;
	CButton	m_CHKshowGrid;
	CButton	m_CHKwater;
	CListBox	m_LISTstart;
	CSpinButtonCtrl	m_SPINwaterLevel;
	CListBox	m_LISTtileset;
	CListBox	m_LISTconsole;
	CStatic	m_MAINVIEW;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapEditorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMapEditorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButton2();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnBTnewMap();
	afx_msg void OnBTsaveMap();
	afx_msg void OnBTloadMap();
	afx_msg void OnCHKshowGrid();
	afx_msg void OnBTaddStart();
	afx_msg void OnCHKaddTrees();
	afx_msg void OnCHKremoveTrees();
	afx_msg void OnBTremoveStart();
	afx_msg void OnSelchangeLISTtileset();
	afx_msg void OnSelchangeLISTfeatures();
	afx_msg void OnSetfocusLISTtileset();
	afx_msg void OnSetfocusLISTfeatures();
	afx_msg void OnDblclkLISTfeatures();
	afx_msg void OnDblclkLISTtileset();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnBTclearAllFeats();
	afx_msg void OnCHKflipHoriz();
	afx_msg void OnCHKflipVert();
	afx_msg void OnCHKsnapToGrid();
	afx_msg void OnBTresizeMap();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPEDITORDLG_H__90F747E2_D3A0_42AD_B82B_8B03DB89C6C2__INCLUDED_)
