
#include "stdafx.h"
#include "Modeller.h"
#include "MetalWar.h"



S_MESH *S_MESH::optimise(void)
{


//loop all polys...
	S_POLY *cpoly = this->pfirst;

	while(cpoly)
	{



//loop all polygons....
		S_POLY *cpoly2 = this->pfirst;

		while(cpoly2)
		{


			cpoly->invisible = 1;

			if (cpoly->hasAnySimiliarVerts(cpoly2))
			{
				
				cpoly->invisible = 0;

			}


			cpoly2 = cpoly2->pnext;
		}
//===========================



		cpoly = cpoly->pnext;
	}




	return this;
}


//===========================

int S_POLY::hasAnySimiliarVerts( S_POLY *p1 )
{

	S_VERTEX *currentVertex = this->firstVertex;
	
	while(1)
	{
		
		if (!currentVertex) break;


		if (currentVertex->hasAnySimiliarVerts(p1))
		{
			return 1;
		}
		
		
		S_EDGE *thisEdge = currentVertex->nextEdge;
		
		if (!thisEdge) break;
		
		S_VERTEX *nextVertex = thisEdge->nextVertex;
		
		if (!nextVertex) break;
		
		currentVertex = nextVertex;
		if (currentVertex == this->firstVertex) break;
	}
	
	return 0;
}

//===========================

int	S_VERTEX::hasAnySimiliarVerts( S_POLY *p2 )
{

	S_VERTEX *currentVertex = p2->firstVertex;
	
	while(1)
	{
		
		if (!currentVertex) break;


		if (this->x == currentVertex->x && this->y == currentVertex->y && this->z == currentVertex->z)
		{
			return 1;
		}
		
		
		S_EDGE *thisEdge = currentVertex->nextEdge;
		
		if (!thisEdge) break;
		
		S_VERTEX *nextVertex = thisEdge->nextVertex;
		
		if (!nextVertex) break;
		
		currentVertex = nextVertex;
		if (currentVertex == p2->firstVertex) break;
	}
	
	return 0;
}

//===========================


void S_MESH::makeVerticesUnique(S_MESH *newMesh)
{

/*	S_POLY *cpoly = this->pfirst;
	do {

		if (!cpoly) break;

		S_POLY *newPolygon = new S_POLY();

		for (int ce=0; ce < cpoly->numEdges; ce++)
		{
			if (cpoly->e[ce].visible)
			{

				S_VERTEX *newv1 = new S_VERTEX( *(cpoly->e[ce].v1) );
				S_VERTEX *newv2 = new S_VERTEX( *(cpoly->e[ce].v2) );

				newv1->testFlag = 0;
				newv2->testFlag = 0;

				(*newMesh) += newv1;
				(*newMesh) += newv2;

				S_EDGE	*newEdge = new S_EDGE( newv1, newv2 );

				(*newPolygon) += newEdge;
			}

		}

		if (newPolygon->numEdges) (*newMesh) += newPolygon;

		cpoly = cpoly->pnext;
	} while(1);*/

}



void S_MESH::ajoinPolygons( void )
{

/*	S_POLY *cpoly = this->pfirst;
	S_POLY *endPoly = this->plast;

	while( cpoly != endPoly )
	{

		if (S_POLY *ppoly = cpoly->findPlanarPolygon( this, 1, endPoly ))
		{
			//ppoly->invisible = 1;
			
			S_POLY *newPoly = new S_POLY();
			
			for (int ce=0; ce< cpoly->numEdges; ce++)
			{

				S_EDGE *nedge = new S_EDGE( cpoly->e[ce].v1, cpoly->e[ce].v2 );
				(*newPoly) += nedge;
			}

			for (ce=0; ce< ppoly->numEdges; ce++)
			{
				S_EDGE *nedge = new S_EDGE( ppoly->e[ce].v1, ppoly->e[ce].v2 );
				(*newPoly) += nedge;
			}

			(*this) += newPoly;
		}

		cpoly = cpoly->pnext;
	}
*/
}




S_POLY	*S_POLY::findPlanarPolygon( S_MESH *mesh, int isSameMesh, S_POLY *endPoly )
{
	
/*	if (this->numEdges < 2) return NULL;

	VECTOR Edge1, Edge2, t_NormalA, t_NormalB;
	
	Edge1.set(this->e[0].v2->x-this->e[0].v1->x, this->e[0].v2->y-this->e[0].v1->y, this->e[0].v2->z-this->e[0].v1->z);
	Edge2.set(this->e[1].v2->x-this->e[1].v1->x, this->e[1].v2->y-this->e[1].v1->y, this->e[1].v2->z-this->e[1].v1->z);
							
	t_NormalA = MWCrossProduct(&Edge1, &Edge2);
	t_NormalA.MakeUnit();


	S_POLY *cpoly = mesh->pfirst;

	while( cpoly != endPoly )
	{

		if (cpoly->numEdges >= 2 && (!isSameMesh || (isSameMesh && this != cpoly)) )
		{

			Edge1.set(cpoly->e[0].v2->x-cpoly->e[0].v1->x, cpoly->e[0].v2->y-cpoly->e[0].v1->y, cpoly->e[0].v2->z-cpoly->e[0].v1->z);
			Edge2.set(cpoly->e[1].v2->x-cpoly->e[1].v1->x, cpoly->e[1].v2->y-cpoly->e[1].v1->y, cpoly->e[1].v2->z-cpoly->e[1].v1->z);
							
			t_NormalB = MWCrossProduct(&Edge1, &Edge2);
			t_NormalB.MakeUnit();


			int	exacts = 0;
			int negatives = 0;

			if (t_NormalA.x == t_NormalB.x) exacts++;
			else if (t_NormalA.x == -t_NormalB.x) negatives ++;

			if (t_NormalA.y == t_NormalB.y) exacts++;
			else if (t_NormalA.y == -t_NormalB.y) negatives ++;

			if (t_NormalA.z == t_NormalB.z) exacts++;
			else if (t_NormalA.z == -t_NormalB.z) negatives ++;

			if (exacts == 3) return cpoly;
			if (exacts == 2 && negatives == 1) return cpoly;
		}

		cpoly = cpoly->pnext;
	}
*/
	return NULL;
}








void S_MESH::removeUnusedVerts(void)
{


/*	S_VERTEX *cvert = this->vfirst;
	do {

		if (!cvert) break;

		cvert->testFlag = 0;

		cvert = cvert->vnext;
	} while(1);




	S_POLY *cpoly = this->pfirst;
	do {

		if (!cpoly) break;

		if (cpoly->invisible){// || cpoly->numEdges < 3){
		
			S_POLY *nextPoly = cpoly->pnext;
			(*this) -= cpoly;
		
			cpoly = nextPoly;
			continue;
		
		}

		for (int ce=0; ce < cpoly->numEdges; ce++)
		{
			cpoly->e[ce].v1->testFlag = 1;
			cpoly->e[ce].v2->testFlag = 1;

		}

		cpoly = cpoly->pnext;
	} while(1);



	cvert = this->vfirst;
	do {

		if (!cvert) break;

		if (!cvert->testFlag) {

			S_VERTEX *nextVert = cvert->vnext;
			(*this) -= cvert;
			cvert = nextVert;
			continue;

		}

		cvert = cvert->vnext;
	} while(1);*/

}